unit Unit1;

//-- This is a very simple, very crude and not very documentated
//-- program in order to test the functionality of AKRip32.dll
//-- History:
//-- 09. January 2000:  First released version
//-- 06. February 2000: CDDBGetServerList example
//--                    extended the CDDB-Query (now gets DiskInfo as well)
//--                    added some checks for results and valid CDHandles




interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AKRip32;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button8: TButton;
    Memo1: TMemo;
    Button7: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    FCDHandle: HCDROM;
    function CheckCDHandle: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-- Prints the version of AKRip32

procedure TForm1.Button1Click(Sender: TObject);
var
  Ver: DWord;
begin
  Ver := GetAKRipDllVersion;
  Memo1.Lines.Add(Format('AK-Rip V%d.%d', [Hi(Ver), Lo(Ver)]));
end;

//-- Lists all available CD-Rom drives

procedure TForm1.Button2Click(Sender: TObject);
var
  MyList: CDLIST;
  i: Integer;
begin
  MyList.Max := MAXCDLIST;
  GetCDList(MyList);
  if MyList.Num = 0 then
  begin
    Memo1.Lines.Add('No CD-Rom-Drives found!');
    Exit;
  end;

  for i := 0 to MyList.Num - 1 do
    Memo1.Lines.Add(MyList.Cd[i].id);
end;

//-- gets a handle of CD drive at 0:1:0

procedure TForm1.Button3Click(Sender: TObject);
var
  MyGetCD: GETCDHAND;
begin
  if FCDHandle > 0 then
  begin
    Memo1.Lines.Add('I have already a CD Handle!');
    Exit;
  end;

  with MyGetCD do
  begin
    Size := SizeOf(GETCDHAND);
    Ver := 1; //-- Version of AKRip32 dll. Should be set to 1 as of this release.
    ha := 0; //-- Host adapter number of CD-ROM unit
    tgt := 1; //-- Target number of CD-ROM unit
    lun := 0; //-- LUN of CD-ROM unit
    readType := CDR_ANY; //-- Read algorithm to use: can be one of CDR_ANY, CDR_ATAPI1, CDR_ATAPI2, CDR_READ10, CDR_READ_D8, CDR_READ_D4 or CDR_READ_D4_1
    jitterCorr := false; //-- Ignored by the current implementation
    numJitter := 0; //-- The number of frames to check. Only affects ReadCDAudioLBAEx.
    numOverlap := 0; //-- The number of frames to overlap. Only affects ReadCDAudioLBAEx.
  end;

  FCDHandle := GetCDHandle(MygetCD);

  if FCDHandle = 0 then
    Memo1.Lines.Add('Error')
  else
    Memo1.Lines.Add('Success');
end;

//-- reads the TOC of the inserted CD associated with the
//-- formerly acquired CD-Handle

procedure TForm1.Button4Click(Sender: TObject);
var
  MyTOC: TOC;
  i, liMin, liSec, liFrames: Integer;
begin
  if not CheckCDHandle then Exit;
  ModifyCDParms(FCDHandle, CDP_MSF, DWORD(true));

  if ReadTOC(FCDHandle, MyTOC) = 1 then
    for i := MyToc.firstTrack to MyToc.lastTrack do
    begin
      liMin := MyToc.tracks[i - 1].addr[1];
      liSec := MyToc.tracks[i - 1].addr[2];
      liFrames := MyToc.tracks[i - 1].addr[3];

      Memo1.Lines.Add(Format('Track %d starts at %d:%.2d,%d', [i, liMin, liSec,
        liFrames]));
    end
  else
    memo1.Lines.Add('Error reading TOC');

end;

//-- helper function for ripping - see below

function newTrackBuf(numFrames: Cardinal): PTRACKBUF;
begin
  //-- Allocate memory for numFrames Frames plus TrackBuf-Data
  GetMem(Result, (numFrames * 2352) + TRACKBUFEXTRA);

  //-- initialize TrackBuf-Data
  Result^.startFrame := 0;
  Result^.numFrames := 0;
  Result^.maxLen := numFrames * 2352;
  Result^.len := 0;
  Result^.status := 0;
  Result^.startOffset := 0;
end;

//-- helper function for ripping: writes a simple
//-- header for a proper WAV-file

procedure writeWavHeader(AFileStream: TFileStream; len: Cardinal);
type
  PWAVHDR = ^WAVHDR;
  WAVHDR = packed record
    riff: array[0..3] of Char; {* must be "RIFF"                *}
    len: DWord; {* #bytes + 44 - 8               *}
    cWavFmt: array[0..7] of Char; {* must be "WAVEfmt"             *}
    dwHdrLen: DWord;
    wFormat: Word;
    wNumChannels: Word;
    dwSampleRate: DWord;
    dwBytesPerSec: DWord;
    wBlockAlign: Word;
    wBitsPerSample: Word;
    cData: array[0..3] of Char; {* must be "data"               *}
    dwDataLen: DWord; {* #bytes                       *}
  end;
var
  wav: WAVHDR;
begin
  wav.riff := 'RIFF';
  wav.len := len + 44 - 8;
  wav.cWavFmt := 'WAVEfmt ';
  wav.dwHdrLen := 16;
  wav.wFormat := 1;
  wav.wNumChannels := 2;
  wav.dwSampleRate := 44100;
  wav.dwBytesPerSec := 44100 * 2 * 2;
  wav.wBlockAlign := 4;
  wav.wBitsPerSample := 16;
  wav.cData := 'data';
  wav.dwDataLen := len;
  AFileStream.Write(wav, SizeOf(WAVHDR));
end;

//-- rips a small portion of the first few seconds of the CD

procedure TForm1.Button5Click(Sender: TObject);
const
  giFrames = 23;
var
  PBuf: PTRACKBUF;
  i: Integer;
  liStatus: Integer;
  MyFileStream: TFileStream;
  MyPChar: PChar;
begin
  if not CheckCDHandle then Exit;
  Screen.Cursor := crHourglass;
  try
    PBuf := newTrackBuf(giFrames);

    MyFileStream := TFileStream.Create('track.wav', fmCreate);
    try
      MyFileStream.Position := 0;
      writeWavHeader(MyFileStream, 100 * giFrames * 2352);

      for i := 1 to 100 do
      begin
        PBuf^.startFrame := (i - 1) * giFrames;
        PBuf^.numFrames := giFrames;

        liStatus := ReadCDAudioLBA(FCDHandle, PBuf);
        Memo1.Lines.Add(Format('Status = %d', [liStatus]));

        MyPChar := PChar(Addr(PBuf^.buf)) + PBuf^.startOffset;
        MyFileStream.Write(MyPChar^, PBuf^.len);
      end;
    finally
      MyFileStream.Free;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

//-- Get the list of CDDB Servers

procedure TForm1.Button6Click(Sender: TObject);
var
  cs: array[0..7] of CDDBSITE;
  csl: CDDBSITELIST;
  i: Integer;
begin
  Screen.Cursor := crHourglass;
  try
    FillChar(cs, SizeOf(CDDBSITE) * 8, 0);
    csl.num := 8;
    csl.s := PCDDBSITE(Addr(cs));
    CDDBSetOption(CDDB_OPT_SERVER, 'www.freedb.org', 0);
    CDDBSetOption(CDDB_OPT_CGI, '/~cddb/cddb.cgi', 0);
    CDDBSetOption(CDDB_OPT_USER, 'user@akrip.sourceforge.net', 0);
    CDDBSetOption(CDDB_OPT_AGENT, 'program 1.0', 0);
    if CDDBGetServerList(csl) <> 1 then
    begin
      Memo1.Lines.Add('Error during CDDBGetServerList!'); ;
      Exit;
    end;

    Memo1.Lines.Add('The following servers were found:'); ;
    for i := 0 to csl.num - 1 do
    begin
      if i >= 8 then Break;
      Memo1.Lines.Add(Format('%d: Server=%s, ,Port=%d, CGI=%s, North=%s, South=%s, Location=%s',
        [i, cs[i].szServer, cs[i].iPort, cs[i].szCGI, cs[i].szNorth, cs[i].szSouth, cs[i].szLocation]));
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

//-- Query the CD from CDDB

procedure TForm1.Button7Click(Sender: TObject);
var
  qi: array[0..4] of CDDBQUERYITEM;
  query: TCDDBQUERY;
  i: Integer;
  lsVal: string;
begin
  if not CheckCDHandle then Exit;
  Screen.Cursor := crHourglass;
  try
    FillChar(qi, SizeOf(CDDBQUERYITEM) * 5, 0);
    query.num := 5; // set to the length of qi
    query.q := PCDDBQUERYITEM(Addr(qi));
    CDDBSetOption(CDDB_OPT_SERVER, 'www.freedb.org', 0);
    CDDBSetOption(CDDB_OPT_CGI, '/~cddb/cddb.cgi', 0);
    CDDBSetOption(CDDB_OPT_USER, 'user@akrip.sourceforge.net', 0);
    CDDBSetOption(CDDB_OPT_AGENT, 'program 1.0', 0);
    CDDBQuery(FCDHandle, query);
    if query.num > 0 then
    begin
      Memo1.Lines.Add('The following matches were found:'); ;
      for i := 0 to query.num - 1 do
      begin
        Memo1.Lines.Add(Format('%d: %s %s %s / %s', [i, qi[i].categ,
          qi[i].cddbId, qi[i].artist, qi[i].title]));
        SetLength(lsVal, 32000);
        if CDDBGetDiskInfo(qi[i], PChar(lsVal), 32000) = 1 then
        begin
          Memo1.Lines.Add(lsVal);
        end
        else
          Memo1.Lines.Add('Error while getting DiskInfo');
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

//-- simply closes the CD-Handle

procedure TForm1.Button8Click(Sender: TObject);
begin
  if not CheckCDHandle then Exit;
  if CloseCDHandle(FCDHandle) <> true then
    Memo1.Lines.Add('Error')
  else
  begin
    Memo1.Lines.Add('Success');
    FCDHandle := 0;
  end;
end;

function TForm1.CheckCDHandle: Boolean;
begin
  Result := false;
  if FCDHandle = 0 then
  begin
    Memo1.Lines.Add('Need valid CD handle first!');
    Exit;
  end;
  Result := true;
end;

end.

